library dorb;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  value in '..\src\orb\value.pas',
  any in '..\src\orb\any.pas',
  boa in '..\src\orb\boa.pas',
  buffer in '..\src\orb\buffer.pas',
  codec in '..\src\orb\codec.pas',
  codeset in '..\src\orb\codeset.pas',
  codeset_ref in '..\src\orb\codeset_ref.pas',
  coseventchanneladmin in '..\src\orb\coseventchanneladmin.pas',
  coseventcomm in '..\src\orb\coseventcomm.pas',
  cosnaming in '..\src\orb\cosnaming.pas',
  decoder in '..\src\orb\decoder.pas',
  disp in '..\src\orb\disp.pas',
  encoder in '..\src\orb\encoder.pas',
  env in '..\src\orb\env.pas',
  exceptions in '..\src\orb\exceptions.pas',
  iiop in '..\src\orb\iiop.pas',
  imr in '..\src\orb\imr.pas',
  imr_impl in '..\src\orb\imr_impl.pas',
  Intercept in '..\src\orb\intercept.pas',
  iop in '..\src\orb\iop.pas',
  ior in '..\src\orb\ior.pas',
  ir in '..\src\orb\ir.pas',
  ir_value in '..\src\orb\ir_value.pas',
  map in '..\src\orb\map.pas',
  orb in '..\src\orb\orb.pas',
  orbcomp in '..\src\orb\orbcomp.pas',
  poa in '..\src\orb\poa.pas',
  poa_except in '..\src\orb\poa_except.pas',
  poa_impl in '..\src\orb\poa_impl.pas',
  policies in '..\src\orb\policies.pas',
  proxy in '..\src\orb\proxy.pas',
  pstream in '..\src\orb\pstream.pas',
  req in '..\src\orb\req.pas',
  static in '..\src\orb\static.pas',
  std_seq in '..\src\orb\std_seq.pas',
  stdstat in '..\src\orb\stdstat.pas',
  tcode in '..\src\orb\tcode.pas',
  throw in '..\src\orb\throw.pas',
  transp in '..\src\orb\transp.pas',
  utils in '..\src\orb\utils.pas',
  address in '..\src\orb\address.pas',
  value_int in '..\src\orbint\value_int.pas',
  boa_int in '..\src\orbint\boa_int.pas',
  code_int in '..\src\orbint\code_int.pas',
  comp_int in '..\src\orbint\comp_int.pas',
  coseventchanneladmin_int in '..\src\orbint\coseventchanneladmin_int.pas',
  cosnaming_int in '..\src\orbint\cosnaming_int.pas',
  disp_int in '..\src\orbint\disp_int.pas',
  env_int in '..\src\orbint\env_int.pas',
  event_int in '..\src\orbint\event_int.pas',
  except_int in '..\src\orbint\except_int.pas',
  giop_int in '..\src\orbint\giop_int.pas',
  iiop_int in '..\src\orbint\iiop_int.pas',
  iior_int in '..\src\orbint\iior_int.pas',
  imr_int in '..\src\orbint\imr_int.pas',
  Intercept_int in '..\src\orbint\intercept_int.pas',
  ir_int in '..\src\orbint\ir_int.pas',
  localreq_int in '..\src\orbint\localreq_int.pas',
  map_int in '..\src\orbint\map_int.pas',
  mcomp_int in '..\src\orbint\mcomp_int.pas',
  orb_int in '..\src\orbint\orb_int.pas',
  poa_int in '..\src\orbint\poa_int.pas',
  policy_int in '..\src\orbint\policy_int.pas',
  req_int in '..\src\orbint\req_int.pas',
  addr_int in '..\src\orbint\addr_int.pas',
  context in '..\src\orb\context.pas',
  MtDorbSSLOpenSSLHeaders in '..\src\orb\MtDorbSSLOpenSSLHeaders.pas',
  mtmanager in '..\src\orb\mtmanager.pas',
  mtmanager_int in '..\src\orbint\mtmanager_int.pas',
  ssl in '..\src\orb\ssl.pas',
  osthread in '..\src\orb\osthread.pas',
  osnet in '..\src\orb\osnet.pas',
  orbtypes in '..\src\orb\orbtypes.pas',
  coseventcomm_int in '..\src\orbint\coseventcomm_int.pas';

{$R *.RES}
begin
end.
